package ctbrec.ui.settings;

import ctbrec.Config;
import ctbrec.Recording;
import ctbrec.StringUtil;
import ctbrec.UnknownModel;
import ctbrec.recorder.Recorder;
import ctbrec.recorder.postprocessing.PostProcessingContext;
import ctbrec.sites.chaturbate.Chaturbate;
import ctbrec.ui.controls.Dialogs;
import ctbrec.ui.tabs.DownloadPostprocessor;
import ctbrec.variableexpansion.functions.AntlrSyntacErrorAdapter;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.GridPane;
import javafx.scene.layout.Priority;
import org.antlr.v4.runtime.RecognitionException;
import org.antlr.v4.runtime.Recognizer;

import java.nio.file.Paths;
import java.time.Instant;

public class VariablePlayGroundDialogFactory {
    public void openDialog(Scene parent, Config config, Recorder recorder) {
        Chaturbate chaturbate = new Chaturbate();
        UnknownModel unknownModel = new UnknownModel();
        unknownModel.setName("Pussy_Galore");
        unknownModel.setDisplayName("Pussy Galore");
        unknownModel.setSite(chaturbate);
        Recording recording = new Recording();
        recording.setAbsoluteFile(Paths.get("ctbrec", "recs", "pussy_galore", "2023-02-26_14-05-56").toFile());
        recording.setStartDate(Instant.now());
        recording.setStatus(Recording.State.POST_PROCESSING);
        recording.setNote("notes about the recording");
        recording.setModel(unknownModel);
        PostProcessingContext ctx = new PostProcessingContext();
        ctx.setConfig(config);
        ctx.setRecorder(recorder);
        ctx.setRecording(recording);
        DownloadPostprocessor postprocessor = new DownloadPostprocessor();

        GridPane pane = new GridPane();
        Label result = new Label();
        Label error = new Label();

        pane.add(new Label("Expression"), 0, 0);
        TextField input = new TextField();
        input.setMinWidth(600);
        pane.add(input, 1, 0);
        GridPane.setHgrow(input, Priority.ALWAYS);
        input.setOnKeyTyped(evt -> {
            String r = postprocessor.fillInPlaceHolders(input.getText(), ctx, new AntlrSyntacErrorAdapter() {
                @Override
                public void syntaxError(Recognizer<?, ?> recognizer, Object o, int line, int pos, String s, RecognitionException e) {
                    error.setText(String.format("Syntax error at %d:%d %s", line, pos, s));
                }
            });
            result.setText(r);
            if (StringUtil.isNotBlank(r)) {
                error.setText("");
            }
        });

        pane.add(error, 0, 1);
        GridPane.setColumnSpan(error, 2);

        pane.add(result, 0, 2);
        GridPane.setColumnSpan(result, 2);

        pane.setHgap(5);
        pane.vgapProperty().bind(pane.hgapProperty());
        Dialogs.showCustomInput(parent, "Playground", pane, (obs, oldV, newV) -> {
        });
    }
}
